--- old-encfs-1.2/encfs/FileNode.cpp	2005-05-17 21:01:55.000000000 +0200
+++ new-encfs-1.2/encfs/FileNode.cpp	2005-06-28 14:31:26.000000000 +0200
@@ -21,6 +21,7 @@
 
 #include <errno.h>
 #include <sys/stat.h>
+#include <sys/types.h>
 #include <fcntl.h>
 #include <unistd.h>
 #include <sys/fsuid.h>
@@ -129,6 +130,19 @@
     return _pname.c_str();
 }
 
+static bool setIV(const Ptr<FileIO> &io, uint64_t iv)
+{
+    struct stat stbuf;
+    if(io->getAttr(&stbuf) < 0)
+	return false;
+
+    // only use setIV if the file is a regular (not link, etc)
+    if(S_ISREG(stbuf.st_mode))
+	return io->setIV( iv );
+    else
+	return true;
+}
+
 bool FileNode::setName( const char *plaintextName_, const char *cipherName_,
 	uint64_t iv, bool setIVFirst )
 {
@@ -137,7 +151,7 @@
     rDebug("calling setIV on %s", cipherName_);
     if(setIVFirst)
     {
-	if(externalIVChaining && !io->setIV( iv ))
+	if(externalIVChaining && !setIV(io, iv))
 	    return false;
 
 	// now change the name..
@@ -161,7 +175,7 @@
 	    io->setFileName( cipherName_ );
 	}
 
-	if(externalIVChaining && !io->setIV( iv ))
+	if(externalIVChaining && !setIV(io, iv))
 	{
 	    _pname = oldPName;
 	    _cname = oldCName;

